/* MeigaServer.c generated by valac, the Vala compiler
 * generated from MeigaServer.vala, do not modify */

/* Meiga - Lightweight and easy to use web file server for your desktop
 *
 * Copyright (C) 2009 Igalia, S.L.
 *
 * Authors:
 *
 * Igalia, S.L. <info@igalia.com>
 * Enrique Ocaña González <eocanha@igalia.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>
#include <locale.h>
#include <dbus/dbus.h>


#define TYPE_MEIGA_SERVER (meiga_server_get_type ())
#define MEIGA_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEIGA_SERVER, MeigaServer))
#define MEIGA_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEIGA_SERVER, MeigaServerClass))
#define IS_MEIGA_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEIGA_SERVER))
#define IS_MEIGA_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEIGA_SERVER))
#define MEIGA_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEIGA_SERVER, MeigaServerClass))

typedef struct _MeigaServer MeigaServer;
typedef struct _MeigaServerClass MeigaServerClass;
typedef struct _MeigaServerPrivate MeigaServerPrivate;

#define TYPE_MEIGA (meiga_get_type ())
#define MEIGA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEIGA, Meiga))
#define MEIGA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEIGA, MeigaClass))
#define IS_MEIGA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEIGA))
#define IS_MEIGA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEIGA))
#define MEIGA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEIGA, MeigaClass))

typedef struct _Meiga Meiga;
typedef struct _MeigaClass MeigaClass;

#define TYPE_NET (net_get_type ())
#define NET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NET, Net))
#define NET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NET, NetClass))
#define IS_NET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NET))
#define IS_NET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NET))
#define NET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NET, NetClass))

typedef struct _Net Net;
typedef struct _NetClass NetClass;

#define TYPE_LOG (log_get_type ())
#define LOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOG, Log))
#define LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOG, LogClass))
#define IS_LOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOG))
#define IS_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOG))
#define LOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOG, LogClass))

typedef struct _Log Log;
typedef struct _LogClass LogClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _dbus_g_connection_unref0(var) ((var == NULL) ? NULL : (var = (dbus_g_connection_unref (var), NULL)))
#define _g_mapped_file_free0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_free (var), NULL)))
#define __g_list_free_g_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_free (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _soup_uri_free0(var) ((var == NULL) ? NULL : (var = (soup_uri_free (var), NULL)))

#define TYPE_RSS_FEED (rss_feed_get_type ())
#define RSS_FEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSS_FEED, RssFeed))
#define RSS_FEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSS_FEED, RssFeedClass))
#define IS_RSS_FEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSS_FEED))
#define IS_RSS_FEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSS_FEED))
#define RSS_FEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSS_FEED, RssFeedClass))

typedef struct _RssFeed RssFeed;
typedef struct _RssFeedClass RssFeedClass;
typedef struct _DBusObjectVTable _DBusObjectVTable;

struct _MeigaServer {
	GObject parent_instance;
	MeigaServerPrivate * priv;
};

struct _MeigaServerClass {
	GObjectClass parent_class;
};

struct _MeigaServerPrivate {
	gint port;
	SoupServer* server;
	GHashTable* path_mapping;
	GHashTable* mimetypes;
	Meiga* exposed;
	Net* net;
	guint pending_requests;
	guint total_requests;
	Log* _logger;
	guint _gui_pid;
	char* _display;
};

struct _DBusObjectVTable {
	void (*register_object) (DBusConnection*, const char*, void*);
};


static gpointer meiga_server_parent_class = NULL;

GType meiga_server_get_type (void);
GType meiga_get_type (void);
GType net_get_type (void);
GType log_get_type (void);
#define MEIGA_SERVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MEIGA_SERVER, MeigaServerPrivate))
enum  {
	MEIGA_SERVER_DUMMY_PROPERTY,
	MEIGA_SERVER_LOGGER,
	MEIGA_SERVER_GUI_PID,
	MEIGA_SERVER_DISPLAY
};
#define MEIGA_SERVER_MIME_TYPES_FILE "/etc/mime.types"
MeigaServer* meiga_server_new (void);
MeigaServer* meiga_server_construct (GType object_type);
Log* meiga_server_get_logger (MeigaServer* self);
void log_log (Log* self, const char* msg);
static void meiga_server_log (MeigaServer* self, const char* msg);
Log* log_new (void);
Log* log_construct (GType object_type);
static void meiga_server_set_logger (MeigaServer* self, Log* value);
static void meiga_server_initialize_mimetypes (MeigaServer* self);
void meiga_server_serve_file_callback_default (MeigaServer* self, SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client);
static void _meiga_server_serve_file_callback_default_soup_server_callback (SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client, gpointer self);
void meiga_server_serve_rss_callback (MeigaServer* self, SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client);
static void _meiga_server_serve_rss_callback_soup_server_callback (SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client, gpointer self);
static void meiga_server_initialize_dbus (MeigaServer* self);
void meiga_server_initialize (MeigaServer* self);
Net* net_new (void);
Net* net_construct (GType object_type);
void net_set_logger (Net* self, Log* value);
void net_set_port (Net* self, gint value);
const char* meiga_server_get_display (MeigaServer* self);
void net_set_display (Net* self, const char* value);
#define NET_REDIRECTION_TYPE_NONE 0
void net_set_redirection_type (Net* self, gint value);
char* meiga_server_get_public_url (MeigaServer* self);
static void _lambda9_ (Net* s, GParamSpec* p, MeigaServer* self);
static void __lambda9__g_object_notify (Net* _sender, GParamSpec* pspec, gpointer self);
static void _lambda10_ (Net* s, GParamSpec* p, MeigaServer* self);
static void __lambda10__g_object_notify (Net* _sender, GParamSpec* pspec, gpointer self);
static void _lambda11_ (Net* s, GParamSpec* p, MeigaServer* self);
static void __lambda11__g_object_notify (Net* _sender, GParamSpec* pspec, gpointer self);
void meiga_server_initialize_net (MeigaServer* self);
Meiga* meiga_new (MeigaServer* server);
Meiga* meiga_construct (GType object_type, MeigaServer* server);
static guint _dynamic_request_name0 (DBusGProxy* self, const char* param1, guint param2, GError** error);
char* net_get_url (Net* self);
static gboolean _lambda12_ (MeigaServer* self);
static gboolean __lambda12__gsource_func (gpointer self);
void meiga_server_shutdown (MeigaServer* self);
void meiga_server_set_port (MeigaServer* self, gint port);
static void meiga_server_set_gui_pid (MeigaServer* self, guint value);
static void meiga_server_set_display (MeigaServer* self, const char* value);
void meiga_server_register_gui (MeigaServer* self, guint gui_pid, const char* display);
guint meiga_server_get_gui_pid (MeigaServer* self);
void meiga_server_serve_file_callback (MeigaServer* self, SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client);
static void _meiga_server_serve_file_callback_soup_server_callback (SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client, gpointer self);
void meiga_server_register_path (MeigaServer* self, const char* real_path, const char* logical_path);
void meiga_server_unregister_path (MeigaServer* self, const char* logical_path);
gint net_get_redirection_type (Net* self);
gint meiga_server_get_redirection_type (MeigaServer* self);
void meiga_server_set_redirection_type (MeigaServer* self, gint redirection_type);
#define NET_REDIRECTION_STATUS_NONE 0
gint net_get_redirection_status (Net* self);
gint meiga_server_get_redirection_status (MeigaServer* self);
void net_set_ssh_host (Net* self, const char* value);
void meiga_server_set_ssh_host (MeigaServer* self, const char* ssh_host);
void net_set_ssh_port (Net* self, const char* value);
void meiga_server_set_ssh_port (MeigaServer* self, const char* ssh_port);
void net_set_ssh_user (Net* self, const char* value);
void meiga_server_set_ssh_user (MeigaServer* self, const char* ssh_user);
void net_set_ssh_password (Net* self, const char* value);
void meiga_server_set_ssh_password (MeigaServer* self, const char* ssh_password);
GHashTable* meiga_server_get_paths (MeigaServer* self);
char* meiga_server_get_requests_stats (MeigaServer* self);
static void _lambda2_ (MeigaServer* self);
static void __lambda2__soup_message_finished (SoupMessage* _sender, gpointer self);
static char* meiga_server_extension_from_path (MeigaServer* self, const char* path);
static void _g_list_free_g_free (GList* self);
GType rss_feed_get_type (void);
RssFeed* rss_feed_new_from_directory (const char* path, const char* base_url, const char* title, const char* description);
char* rss_feed_to_string (RssFeed* self);
void meiga_server_serve_error (MeigaServer* self, SoupMessage* msg, const char* path, SoupKnownStatusCode _error_, const char* error_message);
void meiga_server_main (char** args, int args_length1);
static void meiga_server_finalize (GObject* obj);
static void meiga_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void meiga_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);
static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object);
static void _vala_dbus_unregister_object (gpointer connection, GObject* object);



MeigaServer* meiga_server_construct (GType object_type) {
	MeigaServer * self;
	self = (MeigaServer*) g_object_new (object_type, NULL);
	return self;
}


MeigaServer* meiga_server_new (void) {
	return meiga_server_construct (TYPE_MEIGA_SERVER);
}


static void meiga_server_log (MeigaServer* self, const char* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	if (self->priv->_logger != NULL) {
		log_log (self->priv->_logger, msg);
	}
}


static void _meiga_server_serve_file_callback_default_soup_server_callback (SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client, gpointer self) {
	meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
}


static void _meiga_server_serve_rss_callback_soup_server_callback (SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client, gpointer self) {
	meiga_server_serve_rss_callback (self, server, msg, path, query, client);
}


void meiga_server_initialize (MeigaServer* self) {
	Log* _tmp0_;
	GHashTable* _tmp1_;
	SoupServer* _tmp2_;
	g_return_if_fail (self != NULL);
	meiga_server_set_logger (self, _tmp0_ = log_new ());
	_g_object_unref0 (_tmp0_);
	self->priv->port = 8001;
	self->priv->pending_requests = (guint) 0;
	self->priv->total_requests = (guint) 0;
	meiga_server_initialize_mimetypes (self);
	self->priv->path_mapping = (_tmp1_ = g_hash_table_new (g_str_hash, g_str_equal), _g_hash_table_unref0 (self->priv->path_mapping), _tmp1_);
	self->priv->server = (_tmp2_ = soup_server_new (SOUP_SERVER_PORT, self->priv->port, NULL), _g_object_unref0 (self->priv->server), _tmp2_);
	soup_server_add_handler (self->priv->server, "/", _meiga_server_serve_file_callback_default_soup_server_callback, g_object_ref (self), g_object_unref);
	soup_server_add_handler (self->priv->server, "/rss", _meiga_server_serve_rss_callback_soup_server_callback, g_object_ref (self), g_object_unref);
	soup_server_run_async (self->priv->server);
	meiga_server_initialize_dbus (self);
}


static void _lambda9_ (Net* s, GParamSpec* p, MeigaServer* self) {
	char* _tmp1_;
	char* _tmp0_;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	meiga_server_log (self, _tmp1_ = g_strdup_printf (_ ("External URL: %s"), _tmp0_ = meiga_server_get_public_url (self)));
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
	g_signal_emit_by_name (self, "model-changed");
}


static void __lambda9__g_object_notify (Net* _sender, GParamSpec* pspec, gpointer self) {
	_lambda9_ (_sender, pspec, self);
}


static void _lambda10_ (Net* s, GParamSpec* p, MeigaServer* self) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	g_signal_emit_by_name (self, "model-changed");
}


static void __lambda10__g_object_notify (Net* _sender, GParamSpec* pspec, gpointer self) {
	_lambda10_ (_sender, pspec, self);
}


static void _lambda11_ (Net* s, GParamSpec* p, MeigaServer* self) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	g_signal_emit_by_name (self, "model-changed");
}


static void __lambda11__g_object_notify (Net* _sender, GParamSpec* pspec, gpointer self) {
	_lambda11_ (_sender, pspec, self);
}


void meiga_server_initialize_net (MeigaServer* self) {
	Net* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->net = (_tmp0_ = net_new (), _g_object_unref0 (self->priv->net), _tmp0_);
	net_set_logger (self->priv->net, self->priv->_logger);
	net_set_port (self->priv->net, self->priv->port);
	net_set_display (self->priv->net, self->priv->_display);
	net_set_redirection_type (self->priv->net, NET_REDIRECTION_TYPE_NONE);
	g_signal_connect_object ((GObject*) self->priv->net, "notify::url", (GCallback) __lambda9__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self->priv->net, "notify::redirection-type", (GCallback) __lambda10__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self->priv->net, "notify::redirection-status", (GCallback) __lambda11__g_object_notify, self, 0);
}


static char* string_strip (const char* self) {
	char* result;
	char* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = g_strdup (self);
	g_strstrip (_result_);
	result = _result_;
	return result;
}


static void meiga_server_initialize_mimetypes (MeigaServer* self) {
	GError * _inner_error_;
	GHashTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	self->priv->mimetypes = (_tmp0_ = g_hash_table_new (g_str_hash, g_str_equal), _g_hash_table_unref0 (self->priv->mimetypes), _tmp0_);
	{
		FILE* f;
		gchar* _tmp1_;
		gint buffline_size;
		gint buffline_length1;
		gchar* buffline;
		char* line;
		f = fopen (MEIGA_SERVER_MIME_TYPES_FILE, "r");
		buffline = (_tmp1_ = g_new0 (gchar, 128), buffline_length1 = 128, buffline_size = buffline_length1, _tmp1_);
		line = NULL;
		if (f == NULL) {
			_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "opening");
			{
				_fclose0 (f);
				buffline = (g_free (buffline), NULL);
				_g_free0 (line);
				if (_inner_error_->domain == G_FILE_ERROR) {
					goto __catch0_g_file_error;
				}
				_fclose0 (f);
				buffline = (g_free (buffline), NULL);
				_g_free0 (line);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		while (TRUE) {
			char* _tmp2_;
			gboolean _tmp3_ = FALSE;
			char** _tmp5_;
			gint buf_size;
			gint buf_length1;
			char** _tmp4_;
			char** buf;
			char* mime;
			char** _tmp9_;
			gint extension_size;
			gint extension_length1;
			char** _tmp7_;
			char* _tmp6_;
			char** _tmp8_;
			char** extension;
			if (!(!feof (f))) {
				break;
			}
			fgets (buffline, buffline_length1, f);
			line = (_tmp2_ = g_strdup ((const char*) buffline), _g_free0 (line), _tmp2_);
			if (line == NULL) {
				_tmp3_ = TRUE;
			} else {
				_tmp3_ = feof (f);
			}
			if (_tmp3_) {
				continue;
			}
			buf = (_tmp5_ = _tmp4_ = g_strsplit_set (line, " \t", 2), buf_length1 = _vala_array_length (_tmp4_), buf_size = buf_length1, _tmp5_);
			mime = string_strip (buf[0]);
			if (buf[1] == NULL) {
				buf = (_vala_array_free (buf, buf_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (mime);
				continue;
			}
			extension = (_tmp9_ = (_tmp8_ = _tmp7_ = g_strsplit_set (_tmp6_ = string_strip (buf[1]), " \t", 0), _g_free0 (_tmp6_), _tmp8_), extension_length1 = _vala_array_length (_tmp7_), extension_size = extension_length1, _tmp9_);
			{
				gint i;
				i = 0;
				{
					gboolean _tmp10_;
					_tmp10_ = TRUE;
					while (TRUE) {
						if (!_tmp10_) {
							i++;
						}
						_tmp10_ = FALSE;
						if (!(extension[i] != NULL)) {
							break;
						}
						g_hash_table_insert (self->priv->mimetypes, string_strip (extension[i]), g_strdup (mime));
					}
				}
			}
			buf = (_vala_array_free (buf, buf_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (mime);
			extension = (_vala_array_free (extension, extension_length1, (GDestroyNotify) g_free), NULL);
		}
		_fclose0 (f);
		buffline = (g_free (buffline), NULL);
		_g_free0 (line);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp11_;
			meiga_server_log (self, _tmp11_ = g_strdup_printf (_ ("Error opening file %s"), MEIGA_SERVER_MIME_TYPES_FILE));
			_g_free0 (_tmp11_);
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static guint _dynamic_request_name0 (DBusGProxy* self, const char* param1, guint param2, GError** error) {
	guint result;
	dbus_g_proxy_call (self, "RequestName", error, G_TYPE_STRING, param1, G_TYPE_UINT, param2, G_TYPE_INVALID, G_TYPE_UINT, &result, G_TYPE_INVALID);
	if (*error) {
		return 0U;
	}
	return result;
}


static void meiga_server_initialize_dbus (MeigaServer* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		Meiga* _tmp0_;
		DBusGConnection* conn;
		DBusGProxy* bus;
		guint request_name_result;
		self->priv->exposed = (_tmp0_ = meiga_new (self), _g_object_unref0 (self->priv->exposed), _tmp0_);
		conn = dbus_g_bus_get (DBUS_BUS_SESSION, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		bus = dbus_g_proxy_new_for_name (conn, "org.freedesktop.DBus", "/org/freedesktop/DBus", "org.freedesktop.DBus");
		request_name_result = _dynamic_request_name0 (bus, "com.igalia.Meiga", (guint) 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_dbus_g_connection_unref0 (conn);
			_g_object_unref0 (bus);
			goto __catch1_g_error;
		}
		if (request_name_result == DBUS_REQUEST_NAME_REPLY_PRIMARY_OWNER) {
			meiga_server_log (self, _ ("Registering DBUS service"));
			_vala_dbus_register_object (dbus_g_connection_get_connection (conn), "/com/igalia/Meiga", G_OBJECT (self->priv->exposed));
		} else {
			meiga_server_log (self, _ ("Not registering DBUS service: not primary owner"));
		}
		_dbus_g_connection_unref0 (conn);
		_g_object_unref0 (bus);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp1_;
			meiga_server_log (self, _tmp1_ = g_strdup_printf (_ ("Error registering DBUS server: %s"), e->message));
			_g_free0 (_tmp1_);
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


char* meiga_server_get_public_url (MeigaServer* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = net_get_url (self->priv->net);
	return result;
}


static gboolean _lambda12_ (MeigaServer* self) {
	gboolean result;
	gtk_main_quit ();
	result = FALSE;
	return result;
}


static gboolean __lambda12__gsource_func (gpointer self) {
	return _lambda12_ (self);
}


void meiga_server_shutdown (MeigaServer* self) {
	g_return_if_fail (self != NULL);
	net_set_redirection_type (self->priv->net, NET_REDIRECTION_TYPE_NONE);
	g_idle_add_full (G_PRIORITY_LOW, __lambda12__gsource_func, g_object_ref (self), g_object_unref);
}


void meiga_server_set_port (MeigaServer* self, gint port) {
	g_return_if_fail (self != NULL);
	self->priv->port = port;
}


void meiga_server_register_gui (MeigaServer* self, guint gui_pid, const char* display) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (display != NULL);
	meiga_server_set_gui_pid (self, gui_pid);
	meiga_server_set_display (self, display);
	if (self->priv->net == NULL) {
		meiga_server_initialize_net (self);
	}
}


static void _meiga_server_serve_file_callback_soup_server_callback (SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client, gpointer self) {
	meiga_server_serve_file_callback (self, server, msg, path, query, client);
}


void meiga_server_register_path (MeigaServer* self, const char* real_path, const char* logical_path) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (real_path != NULL);
	g_return_if_fail (logical_path != NULL);
	if (self->priv->_gui_pid == 0) {
		meiga_server_log (self, _ ("Attempted to register path without GUI started. Ignoring."));
		return;
	}
	if (((const char*) g_hash_table_lookup (self->priv->path_mapping, logical_path)) != NULL) {
		return;
	}
	g_hash_table_insert (self->priv->path_mapping, g_strdup (logical_path), g_strdup (real_path));
	meiga_server_log (self, _tmp0_ = g_strdup_printf (_ ("Registered logical path '%s' to real path '%s'"), logical_path, real_path));
	_g_free0 (_tmp0_);
	soup_server_add_handler (self->priv->server, logical_path, _meiga_server_serve_file_callback_soup_server_callback, g_object_ref (self), g_object_unref);
}


void meiga_server_unregister_path (MeigaServer* self, const char* logical_path) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (logical_path != NULL);
	if (self->priv->_gui_pid == 0) {
		meiga_server_log (self, _ ("Attempted to unregister path without GUI started. Ignoring."));
		return;
	}
	meiga_server_log (self, _tmp0_ = g_strdup_printf (_ ("Unregistered logical path '%s'"), logical_path));
	_g_free0 (_tmp0_);
	g_hash_table_remove (self->priv->path_mapping, logical_path);
}


gint meiga_server_get_redirection_type (MeigaServer* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->net == NULL) {
		result = NET_REDIRECTION_TYPE_NONE;
		return result;
	} else {
		result = net_get_redirection_type (self->priv->net);
		return result;
	}
}


void meiga_server_set_redirection_type (MeigaServer* self, gint redirection_type) {
	g_return_if_fail (self != NULL);
	if (self->priv->net == NULL) {
		return;
	}
	net_set_redirection_type (self->priv->net, redirection_type);
}


gint meiga_server_get_redirection_status (MeigaServer* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->net == NULL) {
		result = NET_REDIRECTION_STATUS_NONE;
		return result;
	} else {
		result = net_get_redirection_status (self->priv->net);
		return result;
	}
}


void meiga_server_set_ssh_host (MeigaServer* self, const char* ssh_host) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_host != NULL);
	if (self->priv->net == NULL) {
		return;
	}
	net_set_ssh_host (self->priv->net, ssh_host);
}


void meiga_server_set_ssh_port (MeigaServer* self, const char* ssh_port) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_port != NULL);
	if (self->priv->net == NULL) {
		return;
	}
	net_set_ssh_port (self->priv->net, ssh_port);
}


void meiga_server_set_ssh_user (MeigaServer* self, const char* ssh_user) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_user != NULL);
	if (self->priv->net == NULL) {
		return;
	}
	net_set_ssh_user (self->priv->net, ssh_user);
}


void meiga_server_set_ssh_password (MeigaServer* self, const char* ssh_password) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_password != NULL);
	if (self->priv->net == NULL) {
		return;
	}
	net_set_ssh_password (self->priv->net, ssh_password);
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* meiga_server_get_paths (MeigaServer* self) {
	GHashTable* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = _g_hash_table_ref0 (self->priv->path_mapping);
	return result;
}


char* meiga_server_get_requests_stats (MeigaServer* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup_printf ("%u/%u", self->priv->pending_requests, self->priv->total_requests);
	return result;
}


static void _lambda2_ (MeigaServer* self) {
	self->priv->pending_requests--;
	g_signal_emit_by_name (self, "model-changed");
}


static void __lambda2__soup_message_finished (SoupMessage* _sender, gpointer self) {
	_lambda2_ (self);
}


static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, (GFunc) g_free, NULL);
	g_list_free (self);
}


void meiga_server_serve_file_callback (MeigaServer* self, SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client) {
	GError * _inner_error_;
	char* real_path;
	char** _tmp1_;
	gint path_tokens_size;
	gint path_tokens_length1;
	char** _tmp0_;
	char** path_tokens;
	char* composed_path;
	char* translated_path;
	gint j;
	char* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (server != NULL);
	g_return_if_fail (path != NULL);
	_inner_error_ = NULL;
	real_path = NULL;
	path_tokens = (_tmp1_ = _tmp0_ = g_strsplit (path, "/", 32), path_tokens_length1 = _vala_array_length (_tmp0_), path_tokens_size = path_tokens_length1, _tmp1_);
	composed_path = g_strdup ("");
	translated_path = g_strdup ("");
	j = 0;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				char* _tmp4_;
				char* _tmp3_;
				char* _tmp5_;
				if (!_tmp2_) {
					i++;
				}
				_tmp2_ = FALSE;
				if (!(path_tokens[i] != NULL)) {
					break;
				}
				if (_vala_strcmp0 (path_tokens[i], "") == 0) {
					continue;
				}
				composed_path = (_tmp4_ = g_strconcat (composed_path, _tmp3_ = g_strconcat ("/", path_tokens[i], NULL), NULL), _g_free0 (composed_path), _tmp4_);
				_g_free0 (_tmp3_);
				translated_path = (_tmp5_ = g_strdup ((const char*) g_hash_table_lookup (self->priv->path_mapping, composed_path)), _g_free0 (translated_path), _tmp5_);
				if (translated_path != NULL) {
					char* _tmp6_;
					real_path = (_tmp6_ = g_strdup (translated_path), _g_free0 (real_path), _tmp6_);
					j = i + 1;
				}
			}
		}
	}
	{
		gint i;
		i = j;
		{
			gboolean _tmp7_;
			_tmp7_ = TRUE;
			while (TRUE) {
				char* _tmp9_;
				char* _tmp8_;
				if (!_tmp7_) {
					i++;
				}
				_tmp7_ = FALSE;
				if (!(path_tokens[i] != NULL)) {
					break;
				}
				real_path = (_tmp9_ = g_strconcat (real_path, _tmp8_ = g_strconcat ("/", path_tokens[i], NULL), NULL), _g_free0 (real_path), _tmp9_);
				_g_free0 (_tmp8_);
			}
		}
	}
	self->priv->pending_requests++;
	self->priv->total_requests++;
	g_signal_emit_by_name (self, "model-changed");
	g_signal_connect_object (msg, "finished", (GCallback) __lambda2__soup_message_finished, self, 0);
	meiga_server_log (self, _tmp10_ = g_strdup_printf (_ ("Request: %s --> Serving: %s"), path, real_path));
	_g_free0 (_tmp10_);
	if (real_path == NULL) {
		meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
		_g_free0 (real_path);
		path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (composed_path);
		_g_free0 (translated_path);
		return;
	} else {
		if (!g_file_test (real_path, G_FILE_TEST_EXISTS)) {
			meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
			_g_free0 (real_path);
			path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (composed_path);
			_g_free0 (translated_path);
			return;
		} else {
			if (g_file_test (real_path, G_FILE_TEST_IS_REGULAR)) {
				GMappedFile* f;
				char* _tmp13_;
				char* _tmp14_;
				char* extension;
				char* mime;
				f = NULL;
				{
					GMappedFile* _tmp11_;
					GMappedFile* _tmp12_;
					_tmp11_ = g_mapped_file_new (real_path, FALSE, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch2_g_file_error;
						}
						_g_mapped_file_free0 (f);
						_g_free0 (real_path);
						path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (composed_path);
						_g_free0 (translated_path);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					f = (_tmp12_ = _tmp11_, _g_mapped_file_free0 (f), _tmp12_);
				}
				goto __finally2;
				__catch2_g_file_error:
				{
					GError * e;
					e = _inner_error_;
					_inner_error_ = NULL;
					{
						meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
						_g_error_free0 (e);
						_g_mapped_file_free0 (f);
						_g_free0 (real_path);
						path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (composed_path);
						_g_free0 (translated_path);
						return;
					}
				}
				__finally2:
				if (_inner_error_ != NULL) {
					_g_mapped_file_free0 (f);
					_g_free0 (real_path);
					path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (composed_path);
					_g_free0 (translated_path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				soup_message_set_status (msg, (guint) SOUP_STATUS_OK);
				extension = (_tmp14_ = g_utf8_strdown (_tmp13_ = meiga_server_extension_from_path (self, real_path), -1), _g_free0 (_tmp13_), _tmp14_);
				mime = NULL;
				if (extension != NULL) {
					char* _tmp15_;
					mime = (_tmp15_ = g_strdup ((const char*) g_hash_table_lookup (self->priv->mimetypes, extension)), _g_free0 (mime), _tmp15_);
				}
				if (mime == NULL) {
					char* _tmp16_;
					mime = (_tmp16_ = g_strdup ("application/x-octet-stream"), _g_free0 (mime), _tmp16_);
				}
				soup_message_set_response (msg, mime, SOUP_MEMORY_COPY, (const char*) g_mapped_file_get_contents (f), g_mapped_file_get_length (f));
				_g_mapped_file_free0 (f);
				_g_free0 (extension);
				_g_free0 (mime);
			} else {
				if (g_file_test (real_path, G_FILE_TEST_IS_DIR)) {
					GList* files;
					GDir* d;
					char* response;
					char* _tmp21_;
					char* _tmp22_;
					char* _tmp23_;
					char* _tmp24_;
					char* _tmp26_;
					char* _tmp25_;
					char* _tmp27_;
					char* _tmp28_;
					char* _tmp29_;
					char* _tmp31_;
					char* _tmp30_;
					char* _tmp33_;
					char* _tmp32_;
					char* _tmp34_;
					char* _tmp42_;
					char* _tmp43_;
					char* _tmp45_;
					char* _tmp44_;
					char* _tmp46_;
					char* _tmp47_;
					files = NULL;
					d = NULL;
					{
						GDir* _tmp17_;
						GDir* _tmp18_;
						_tmp17_ = g_dir_open (real_path, (guint) 0, &_inner_error_);
						if (_inner_error_ != NULL) {
							if (_inner_error_->domain == G_FILE_ERROR) {
								goto __catch3_g_file_error;
							}
							__g_list_free_g_free0 (files);
							_g_dir_close0 (d);
							_g_free0 (real_path);
							path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (composed_path);
							_g_free0 (translated_path);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
						d = (_tmp18_ = _tmp17_, _g_dir_close0 (d), _tmp18_);
						{
							char* f;
							f = g_strdup (g_dir_read_name (d));
							{
								gboolean _tmp19_;
								_tmp19_ = TRUE;
								while (TRUE) {
									if (!_tmp19_) {
										char* _tmp20_;
										f = (_tmp20_ = g_strdup (g_dir_read_name (d)), _g_free0 (f), _tmp20_);
									}
									_tmp19_ = FALSE;
									if (!(f != NULL)) {
										break;
									}
									files = g_list_insert_sorted (files, g_strdup (f), strcmp);
								}
							}
							_g_free0 (f);
						}
					}
					goto __finally3;
					__catch3_g_file_error:
					{
						GError * e;
						e = _inner_error_;
						_inner_error_ = NULL;
						{
							meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
							_g_error_free0 (e);
							__g_list_free_g_free0 (files);
							_g_dir_close0 (d);
							_g_free0 (real_path);
							path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (composed_path);
							_g_free0 (translated_path);
							return;
						}
					}
					__finally3:
					if (_inner_error_ != NULL) {
						__g_list_free_g_free0 (files);
						_g_dir_close0 (d);
						_g_free0 (real_path);
						path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (composed_path);
						_g_free0 (translated_path);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					soup_message_set_status (msg, (guint) SOUP_STATUS_OK);
					response = g_strdup ("");
					response = (_tmp21_ = g_strconcat (response, "<html>\n", NULL), _g_free0 (response), _tmp21_);
					response = (_tmp22_ = g_strconcat (response, "<head>\n", NULL), _g_free0 (response), _tmp22_);
					response = (_tmp23_ = g_strconcat (response, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n", NULL), _g_free0 (response), _tmp23_);
					response = (_tmp24_ = g_strconcat (response, "<title>\n", NULL), _g_free0 (response), _tmp24_);
					response = (_tmp26_ = g_strconcat (response, _tmp25_ = g_strdup_printf (_ ("Index of %s\n"), path), NULL), _g_free0 (response), _tmp26_);
					_g_free0 (_tmp25_);
					response = (_tmp27_ = g_strconcat (response, "</title>\n", NULL), _g_free0 (response), _tmp27_);
					response = (_tmp28_ = g_strconcat (response, "</head>\n", NULL), _g_free0 (response), _tmp28_);
					response = (_tmp29_ = g_strconcat (response, "<body>\n", NULL), _g_free0 (response), _tmp29_);
					response = (_tmp31_ = g_strconcat (response, _tmp30_ = g_strdup_printf ("<!-- generator=\"%s/%s\" -->\n", PACKAGE, VERSION), NULL), _g_free0 (response), _tmp31_);
					_g_free0 (_tmp30_);
					response = (_tmp33_ = g_strconcat (response, _tmp32_ = g_strdup_printf (_ ("Index of %s\n"), path), NULL), _g_free0 (response), _tmp33_);
					_g_free0 (_tmp32_);
					response = (_tmp34_ = g_strconcat (response, "<ul>\n", NULL), _g_free0 (response), _tmp34_);
					{
						GList* f_collection;
						GList* f_it;
						f_collection = files;
						for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
							char* f;
							f = g_strdup ((const char*) f_it->data);
							{
								char* _tmp41_;
								char* _tmp40_;
								char* _tmp39_;
								char* _tmp38_;
								char* _tmp37_;
								char* _tmp36_;
								char* _tmp35_;
								response = (_tmp41_ = g_strconcat (response, _tmp40_ = g_strconcat (_tmp39_ = g_strconcat (_tmp38_ = g_strconcat (_tmp37_ = g_strconcat (_tmp36_ = g_strconcat (_tmp35_ = g_strconcat ("<li><a href=\"", path, NULL), "/", NULL), f, NULL), "\">", NULL), f, NULL), "</a></li>", NULL), NULL), _g_free0 (response), _tmp41_);
								_g_free0 (_tmp40_);
								_g_free0 (_tmp39_);
								_g_free0 (_tmp38_);
								_g_free0 (_tmp37_);
								_g_free0 (_tmp36_);
								_g_free0 (_tmp35_);
								_g_free0 (f);
							}
						}
					}
					response = (_tmp42_ = g_strconcat (response, "</ul>\n", NULL), _g_free0 (response), _tmp42_);
					response = (_tmp43_ = g_strconcat (response, "<br/><br/><i>", NULL), _g_free0 (response), _tmp43_);
					response = (_tmp45_ = g_strconcat (response, _tmp44_ = g_strdup_printf (_ ("Served by <a href=\"http://meiga.igalia.com\">Meiga %s</a>"), VERSION), NULL), _g_free0 (response), _tmp45_);
					_g_free0 (_tmp44_);
					response = (_tmp46_ = g_strconcat (response, "</i>\n", NULL), _g_free0 (response), _tmp46_);
					response = (_tmp47_ = g_strconcat (response, "</body>\n</html>\n", NULL), _g_free0 (response), _tmp47_);
					soup_message_set_response (msg, "text/html", SOUP_MEMORY_COPY, response, (gsize) g_utf8_strlen (response, -1));
					__g_list_free_g_free0 (files);
					_g_dir_close0 (d);
					_g_free0 (response);
				} else {
					meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
				}
			}
		}
	}
	_g_free0 (real_path);
	path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (composed_path);
	_g_free0 (translated_path);
}


void meiga_server_serve_rss_callback (MeigaServer* self, SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client) {
	GError * _inner_error_;
	char* real_path;
	char** _tmp1_;
	gint path_tokens_size;
	gint path_tokens_length1;
	char** _tmp0_;
	char** path_tokens;
	char* composed_path;
	char* translated_path;
	gint j;
	char* _tmp10_;
	SoupURI* uri;
	char* base_url;
	g_return_if_fail (self != NULL);
	g_return_if_fail (server != NULL);
	g_return_if_fail (path != NULL);
	_inner_error_ = NULL;
	real_path = NULL;
	path_tokens = (_tmp1_ = _tmp0_ = g_strsplit (path, "/", 32), path_tokens_length1 = _vala_array_length (_tmp0_), path_tokens_size = path_tokens_length1, _tmp1_);
	composed_path = g_strdup ("");
	translated_path = g_strdup ("");
	j = 0;
	{
		gint i;
		i = 2;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				char* _tmp4_;
				char* _tmp3_;
				char* _tmp5_;
				if (!_tmp2_) {
					i++;
				}
				_tmp2_ = FALSE;
				if (!(path_tokens[i] != NULL)) {
					break;
				}
				if (_vala_strcmp0 (path_tokens[i], "") == 0) {
					continue;
				}
				composed_path = (_tmp4_ = g_strconcat (composed_path, _tmp3_ = g_strconcat ("/", path_tokens[i], NULL), NULL), _g_free0 (composed_path), _tmp4_);
				_g_free0 (_tmp3_);
				translated_path = (_tmp5_ = g_strdup ((const char*) g_hash_table_lookup (self->priv->path_mapping, composed_path)), _g_free0 (translated_path), _tmp5_);
				if (translated_path != NULL) {
					char* _tmp6_;
					real_path = (_tmp6_ = g_strdup (translated_path), _g_free0 (real_path), _tmp6_);
					j = i + 1;
				}
			}
		}
	}
	{
		gint i;
		i = j;
		{
			gboolean _tmp7_;
			_tmp7_ = TRUE;
			while (TRUE) {
				char* _tmp9_;
				char* _tmp8_;
				if (!_tmp7_) {
					i++;
				}
				_tmp7_ = FALSE;
				if (!(path_tokens[i] != NULL)) {
					break;
				}
				real_path = (_tmp9_ = g_strconcat (real_path, _tmp8_ = g_strconcat ("/", path_tokens[i], NULL), NULL), _g_free0 (real_path), _tmp9_);
				_g_free0 (_tmp8_);
			}
		}
	}
	meiga_server_log (self, _tmp10_ = g_strdup_printf (_ ("Request: %s --> Serving (RSS mode): %s"), path, real_path));
	_g_free0 (_tmp10_);
	uri = soup_uri_copy (soup_message_get_uri (msg));
	base_url = g_strdup_printf ("%s://%s:%u", uri->scheme, uri->host, uri->port);
	if (real_path == NULL) {
		meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
		_g_free0 (real_path);
		path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (composed_path);
		_g_free0 (translated_path);
		_soup_uri_free0 (uri);
		_g_free0 (base_url);
		return;
	} else {
		if (!g_file_test (real_path, G_FILE_TEST_EXISTS)) {
			meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
			_g_free0 (real_path);
			path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (composed_path);
			_g_free0 (translated_path);
			_soup_uri_free0 (uri);
			_g_free0 (base_url);
			return;
		} else {
			if (g_file_test (real_path, G_FILE_TEST_IS_REGULAR)) {
				GMappedFile* f;
				char* extension;
				char* mime;
				f = NULL;
				{
					GMappedFile* _tmp11_;
					GMappedFile* _tmp12_;
					_tmp11_ = g_mapped_file_new (real_path, FALSE, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch4_g_file_error;
						}
						_g_mapped_file_free0 (f);
						_g_free0 (real_path);
						path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (composed_path);
						_g_free0 (translated_path);
						_soup_uri_free0 (uri);
						_g_free0 (base_url);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					f = (_tmp12_ = _tmp11_, _g_mapped_file_free0 (f), _tmp12_);
				}
				goto __finally4;
				__catch4_g_file_error:
				{
					GError * e;
					e = _inner_error_;
					_inner_error_ = NULL;
					{
						meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
						_g_error_free0 (e);
						_g_mapped_file_free0 (f);
						_g_free0 (real_path);
						path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (composed_path);
						_g_free0 (translated_path);
						_soup_uri_free0 (uri);
						_g_free0 (base_url);
						return;
					}
				}
				__finally4:
				if (_inner_error_ != NULL) {
					_g_mapped_file_free0 (f);
					_g_free0 (real_path);
					path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (composed_path);
					_g_free0 (translated_path);
					_soup_uri_free0 (uri);
					_g_free0 (base_url);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				soup_message_set_status (msg, (guint) SOUP_STATUS_OK);
				extension = meiga_server_extension_from_path (self, real_path);
				mime = NULL;
				if (extension != NULL) {
					char* _tmp13_;
					mime = (_tmp13_ = g_strdup ((const char*) g_hash_table_lookup (self->priv->mimetypes, extension)), _g_free0 (mime), _tmp13_);
				}
				if (mime == NULL) {
					char* _tmp14_;
					mime = (_tmp14_ = g_strdup ("application/x-octet-stream"), _g_free0 (mime), _tmp14_);
				}
				soup_message_set_response (msg, mime, SOUP_MEMORY_COPY, (const char*) g_mapped_file_get_contents (f), g_mapped_file_get_length (f));
				_g_mapped_file_free0 (f);
				_g_free0 (extension);
				_g_free0 (mime);
			} else {
				if (g_file_test (real_path, G_FILE_TEST_IS_DIR)) {
					char* _tmp16_;
					char* _tmp15_;
					RssFeed* _tmp17_;
					RssFeed* rss;
					char* response;
					soup_message_set_status (msg, (guint) SOUP_STATUS_OK);
					rss = (_tmp17_ = rss_feed_new_from_directory (real_path, _tmp15_ = g_strconcat (base_url, composed_path, NULL), composed_path, _tmp16_ = g_strdup_printf (_ ("Documents under %s"), composed_path)), _g_free0 (_tmp16_), _g_free0 (_tmp15_), _tmp17_);
					response = rss_feed_to_string (rss);
					soup_message_set_response (msg, "application/rss+xml", SOUP_MEMORY_COPY, response, (gsize) g_utf8_strlen (response, -1));
					_g_object_unref0 (rss);
					_g_free0 (response);
				} else {
					meiga_server_serve_file_callback_default (self, server, msg, path, query, client);
				}
			}
		}
	}
	_g_free0 (real_path);
	path_tokens = (_vala_array_free (path_tokens, path_tokens_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (composed_path);
	_g_free0 (translated_path);
	_soup_uri_free0 (uri);
	_g_free0 (base_url);
}


void meiga_server_serve_file_callback_default (MeigaServer* self, SoupServer* server, SoupMessage* msg, const char* path, GHashTable* query, SoupClientContext* client) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (server != NULL);
	g_return_if_fail (msg != NULL);
	g_return_if_fail (path != NULL);
	meiga_server_serve_error (self, msg, path, SOUP_STATUS_NOT_FOUND, _ ("File not found"));
}


void meiga_server_serve_error (MeigaServer* self, SoupMessage* msg, const char* path, SoupKnownStatusCode _error_, const char* error_message) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	g_return_if_fail (path != NULL);
	g_return_if_fail (error_message != NULL);
	soup_message_set_status (msg, (guint) _error_);
	soup_message_set_response (msg, "text/html", SOUP_MEMORY_COPY, error_message, (gsize) g_utf8_strlen (error_message, -1));
	meiga_server_log (self, _tmp0_ = g_strdup_printf ("%d - %s: %s", (gint) _error_, error_message, path));
	_g_free0 (_tmp0_);
}


static char* meiga_server_extension_from_path (MeigaServer* self, const char* path) {
	char* result;
	char** _tmp1_;
	gint token_size;
	gint token_length1;
	char** _tmp0_;
	char** token;
	gint i;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	token = (_tmp1_ = _tmp0_ = g_strsplit (path, ".", 0), token_length1 = _vala_array_length (_tmp0_), token_size = token_length1, _tmp1_);
	i = 0;
	while (TRUE) {
		if (!(token[i] != NULL)) {
			break;
		}
		i++;
	}
	if (i > 0) {
		result = g_strdup (token[i - 1]);
		token = (_vala_array_free (token, token_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		result = NULL;
		token = (_vala_array_free (token, token_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	token = (_vala_array_free (token, token_length1, (GDestroyNotify) g_free), NULL);
}


void meiga_server_main (char** args, int args_length1) {
	MeigaServer* s;
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	s = meiga_server_new ();
	meiga_server_initialize (s);
	gtk_init (&args_length1, &args);
	gtk_main ();
	_g_object_unref0 (s);
	return;
}


int main (int argc, char ** argv) {
	g_thread_init (NULL);
	g_type_init ();
	meiga_server_main (argv, argc);
	return 0;
}


Log* meiga_server_get_logger (MeigaServer* self) {
	Log* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_logger;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void meiga_server_set_logger (MeigaServer* self, Log* value) {
	Log* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_logger = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_logger), _tmp0_);
	g_object_notify ((GObject *) self, "logger");
}


guint meiga_server_get_gui_pid (MeigaServer* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_gui_pid;
	return result;
}


static void meiga_server_set_gui_pid (MeigaServer* self, guint value) {
	g_return_if_fail (self != NULL);
	self->priv->_gui_pid = value;
	g_object_notify ((GObject *) self, "gui-pid");
}


const char* meiga_server_get_display (MeigaServer* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_display;
	return result;
}


static void meiga_server_set_display (MeigaServer* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_display = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_display), _tmp0_);
	g_object_notify ((GObject *) self, "display");
}


static void meiga_server_class_init (MeigaServerClass * klass) {
	meiga_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MeigaServerPrivate));
	G_OBJECT_CLASS (klass)->get_property = meiga_server_get_property;
	G_OBJECT_CLASS (klass)->set_property = meiga_server_set_property;
	G_OBJECT_CLASS (klass)->finalize = meiga_server_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEIGA_SERVER_LOGGER, g_param_spec_object ("logger", "logger", "logger", TYPE_LOG, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEIGA_SERVER_GUI_PID, g_param_spec_uint ("gui-pid", "gui-pid", "gui-pid", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEIGA_SERVER_DISPLAY, g_param_spec_string ("display", "display", "display", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("model_changed", TYPE_MEIGA_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void meiga_server_instance_init (MeigaServer * self) {
	self->priv = MEIGA_SERVER_GET_PRIVATE (self);
	self->priv->_logger = NULL;
	self->priv->_gui_pid = (guint) 0;
	self->priv->_display = NULL;
}


static void meiga_server_finalize (GObject* obj) {
	MeigaServer * self;
	self = MEIGA_SERVER (obj);
	_g_object_unref0 (self->priv->server);
	_g_hash_table_unref0 (self->priv->path_mapping);
	_g_hash_table_unref0 (self->priv->mimetypes);
	_g_object_unref0 (self->priv->exposed);
	_g_object_unref0 (self->priv->net);
	_g_object_unref0 (self->priv->_logger);
	_g_free0 (self->priv->_display);
	G_OBJECT_CLASS (meiga_server_parent_class)->finalize (obj);
}


GType meiga_server_get_type (void) {
	static GType meiga_server_type_id = 0;
	if (meiga_server_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (MeigaServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) meiga_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MeigaServer), 0, (GInstanceInitFunc) meiga_server_instance_init, NULL };
		meiga_server_type_id = g_type_register_static (G_TYPE_OBJECT, "MeigaServer", &g_define_type_info, 0);
	}
	return meiga_server_type_id;
}


static void meiga_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MeigaServer * self;
	self = MEIGA_SERVER (object);
	switch (property_id) {
		case MEIGA_SERVER_LOGGER:
		g_value_set_object (value, meiga_server_get_logger (self));
		break;
		case MEIGA_SERVER_GUI_PID:
		g_value_set_uint (value, meiga_server_get_gui_pid (self));
		break;
		case MEIGA_SERVER_DISPLAY:
		g_value_set_string (value, meiga_server_get_display (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void meiga_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MeigaServer * self;
	self = MEIGA_SERVER (object);
	switch (property_id) {
		case MEIGA_SERVER_LOGGER:
		meiga_server_set_logger (self, g_value_get_object (value));
		break;
		case MEIGA_SERVER_GUI_PID:
		meiga_server_set_gui_pid (self, g_value_get_uint (value));
		break;
		case MEIGA_SERVER_DISPLAY:
		meiga_server_set_display (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}


static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	const _DBusObjectVTable * vtable;
	vtable = g_type_get_qdata (G_TYPE_FROM_INSTANCE (object), g_quark_from_static_string ("DBusObjectVTable"));
	if (vtable) {
		vtable->register_object (connection, path, object);
	} else {
		g_warning ("Object does not implement any D-Bus interface");
	}
}


static void _vala_dbus_unregister_object (gpointer connection, GObject* object) {
	char* path;
	path = g_object_steal_data ((GObject*) object, "dbus_object_path");
	dbus_connection_unregister_object_path (connection, path);
	g_free (path);
}




